package com.upetchflutter.upetchrazorpayplugin;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

import com.razorpay.Checkout;
import com.razorpay.PaymentResultListener;

import org.json.JSONObject;

public class MainActivity extends Activity implements PaymentResultListener {

    public static final String TAG = MainActivity.class.getSimpleName();
    public static String NAME = "name";
    public static String IMAGE = "image";
    public static String DESCRIPTION = "description";
    public static String AMOUNT = "amount";
    public static String PREFILL = "prefill";
    public static String PREFILL_EMAIL = "email";
    public static String PREFILL_CONTACT = "contact";
    public static String THEME = "theme";
    public static String PAYMENT_ID = "payment_id";
    public static String RAZORPAY_KEY = "api_key";
    public static String CURRENCY = "currency";
    public static String COLOR = "color";
    public static String NOTES = "notes";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Intent intent = getIntent();
        Checkout.preload(getApplicationContext());
        startPayment(intent);
    }

    @Override
    public void onPaymentSuccess(String s) {
        try {
            Intent data = new Intent();
            data.putExtra(PAYMENT_ID, s);
            setResult(Activity.RESULT_OK, data);
            finish();
        } catch (Exception e) {
            Log.e(TAG, "Error in onPaymentSuccess", e);
        }
    }

    @Override
    public void onPaymentError(int i, String s) {
        try {
            Intent data = new Intent();
            data.putExtra(PAYMENT_ID, s);
            setResult(Activity.RESULT_CANCELED, data);
            finish();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void startPayment(Intent intent) {
        final Activity activity = this;
        final Checkout _checkout = new Checkout();
        _checkout.setKeyID(intent.getStringExtra(RAZORPAY_KEY));

        try {
            JSONObject options = new JSONObject();
            options.put(NAME, intent.getStringExtra(NAME));
            options.put(DESCRIPTION, intent.getStringExtra(DESCRIPTION));
            options.put(CURRENCY, intent.getStringExtra(CURRENCY));
            options.put(AMOUNT, intent.getStringExtra(AMOUNT));
            options.put(IMAGE, intent.getStringExtra(IMAGE));

            JSONObject prefill = new JSONObject();
            prefill.put(PREFILL_EMAIL, intent.getStringExtra(PREFILL_EMAIL));
            prefill.put(PREFILL_CONTACT, intent.getStringExtra(PREFILL_CONTACT));
            options.put(PREFILL, prefill);

            _checkout.open(activity, options);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}